<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/devices/devices.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/devices/devices.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
*
* This tool summons many typical communication protocols. It allows to connect create different types of connections and to address them in levels.
* It adds a send action to cue creation that allows to send messages to all previously created devices.
* It allows to switch or listen based on the state of the created devices.
*
* References JSON Meta Schema from json-editor node module to allow creating device schemas:
* node_modules/@json-editor/json-editor/docs/meta_schema.json
*
* @requires device
*
* @module devices
*/

const device = require("./device.js")
const tool = require("../tool.js")
const meta_schema = require("../../node_modules/@json-editor/json-editor/docs/meta_schema.json")

var schema = require("./schema.json")


class Devices extends tool.Tool {
  constructor() {
    super(schema)
  }
  
  /**
  * overwrite tool add function:
  * - add a new Device instance with every added collection
  * - add device schema to cue send schema
  * - modify device item update function to make a schema update
  *
  * Note: `this.device` refers to the device items collection instance that holds all device instances.
  * `device` on the other hand is the device.js module
  *
  * inserts meta_schema in device "schema" property
  *
  * @todo meta schema creates unexpected validation errors.
  */
  setup(config) {
    return new Promise((resolve, reject) => {
      this.update(config.settings)
      
      super.setup(config)
      .then(result => {
        this.device.add = data => {
          if(data.schema) {
            schema.cue.send.items.properties[data.name] = data.schema
          } else {
            schema.cue.send.items.properties[data.name] = {}
          }
          
          data["startDefaultLevel"] = this.startDefaultLevel.bind(this)
          
          this.device.items[data.name] = device.getDevice(data, this.db, this.app)
          
          this.schemaUpdate(schema)
        }
        
        this.device.update = (item, changes) => {
          if(changes.updated.hasOwnProperty("settings")) {
            if(changes.updated.settings.interface != this.device.items[item].settings.interface) {
              log.info(this.name, "interface changed for '" + item + "'. Recreating device")
              this.device.items[item] = device.getDevice(changes.document, this.db, this.app)
            }
          }
          if(changes.updated.hasOwnProperty("schema")) {
            schema.cue.send.items.properties[item] = changes.updated.schema
            log.info(this.name, "schema changed for '" + item + "'. Updating")
            this.schemaUpdate(schema)
          }
        }
        
        return this.device.collectItems()
      })
      .then(collected => {
        return device.getPorts()
      })
      .then(ports => {
        log.info(this.name, ports)
        schema.collections.device.properties.settings.oneOf[4].properties.port.enum = ports.serial
        
        schema.collections.device["definitions"] = meta_schema.definitions
        
        device.setVirtualMidiPort(this.name)
        
        resolve(schema)
      })
      .catch(function(error){
        log.error(this.name, error)
        reject(error)
      }.bind(this))
    })
  }
  
  update(settings) {
    if(settings.hasOwnProperty("midi")) {
      if(settings.midi.active) {
        device.activateMidi()
      } else {
        device.deactivateMidi()
      }
    }
  }
  
  /**
  * use device send function if cue contains send property to forward messages
  *
  * @todo wait for device send to return before returning cue
  */
  cue(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "send":
          session.variables.findAndReplace(data[item])
          .then(result => {
            for(let dev in result) {
              this.device.items[dev].send(result[dev])
            }
            return resolve(undefined)
          })
          .catch(error => {
            return reject(error)
          })
          break
        }
      }
    })
  }
  
  /**
	* start a new level
  */
  startDefaultLevel(player_query, default_level) {
    
    this.db.player.find(player_query)
    .then(res => {
      if(!res.length) {
        return this.db.player.insert(player_query)
      } else {
        return
      }
    })
    .then(res => {
      log.info(this.name, "start default level " + default_level + " with player " + JSON.stringify(player_query))
      this.event.emit("create", {level:default_level, player:player_query})
    })
    .catch(err => {
      log.error(this.name, err)
    })
  }
  
  command(input) {
    switch(input[0]) {
      case "list":
      for(let device in this.device.items) {
        log.info(this.name, device)
      }
      break
      case "ports":
      device.getPorts()
      .then(ports => {
        log.info(this.name, ports)
      })
      .catch(function(error){
        log.error(this.name, error)
      }.bind(this))
      break
      case "midi":
      if(input[1] == "on") {
        device.activateMidi()
        log.info(this.name, "please restart plaiframe to reactivate midi")
      } else if(input[1] == "off") {
        device.deactivateMidi()
      }
      break
      default:
      super.command(input)
      break
    }
  }
  
  deviceChanges(changes, device) {
    for(let change in changes) {
      if(change == "schema") {
        schema.cue[device].items.properties = changes[change]
        this.schemaUpdate(schema)
      }
    }
  }
}

module.exports.Plaitool = Devices
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
